
// BitDeph
#define TWPT_BW          0 /* Black and White */
#define TWPT_GRAY        1
#define TWPT_RGB         2
#define TWPT_PALETTE     3

//----- Unit of Measure
#define TWUN_INCHES      0
#define TWUN_CENTIMETERS 1
#define TWUN_PICAS       2
#define TWUN_POINTS      3
#define TWUN_TWIPS       4
#define TWUN_PIXELS      5

//---- File Formats - Formato fichero
#define TW_BMP  2
#define TW_JPG  4



/* ----------------------------------------------------------------
  Small example the aplicattion scanner.
  1.- Scan file JPG  or ClipBoard
  2.- Scan any Region the your scanner, oScan:RegionSet(...)

  (c)2003.- Rafa Carmona( TheFull )
---------------------------------------------------------------  */


Function Main( cFile, nType, nRes, lHide, nPaper, lClipBoard )

   Local hDib := 0
   Local oScan

   // Default RGB
   IF nType == NIL
      nType := TWPT_RGB
   ELSE
      nType := Val( nType )
   ENDIF
   IF cFile = NIL
      cFile := ""
   ENDIF

   //Default 150dpi
   IF nRes = NIL
      nRes := 150
   ELSE
      nRes := Val(nRes)
   ENDIF


   // Default Hide
   IF lHide = "1"
      lHide := .F.
   ELSE
      lHide := .T.
   ENDIF

   // if you used clipboard ;)
   IF lClipBoard = NIL
      lClipBoard := .F.
   ELSE
      lClipBoard := .T.
   ENDIF

   oScan := TScan32():New( cFile )

   oScan:SetRes( nRes )                 // Resolucion 150 by Default.
   oScan:SetHide( lHide )               // Oculto DS
   oScan:PixelType( nType )             // Tipo de Salida Escala de Grises 8/256

   // Si no usa el papel por defecto
   IF nPaper != NIL
      oScan:SetPaper( Val(nPaper) )
   ENDIF

   IF lClipBoard                        // Digitaliza sobre el PortaPapeles ;)
      oScan:AcquireClipBoard()          // Use PASTE Crtl+V in your programa graphics
   ELSE
      oScan:DigiToFile()                // Digitaliza a Fichero!
   ENDIF

   oScan:End()                          // MUY IMPORTANTE!!! Mata el hDib.
                                        // Very Important. End handle hDib.
Return nil


