#INCLUDE "Fivewin.ch"

// BitDeph
#define TWPT_BW          0 /* Black and White */
#define TWPT_GRAY        1
#define TWPT_RGB         2
#define TWPT_PALETTE     3

//----- Unit of Measure
#define TWUN_INCHES      0
#define TWUN_CENTIMETERS 1
#define TWUN_PICAS       2
#define TWUN_POINTS      3
#define TWUN_TWIPS       4
#define TWUN_PIXELS      5


/* ----------------------------------------------------------------
  Control de Pruebas de la Clase TSCAN32, Wrappers
              para Scanners y WebCams.

   - Soporta scanners Paralelo, USB y SCSI.
   - WebCams

  (c)2003.- by Rafa Carmona( TheFull )
  Compiler & Libraries
  - Harbour and Fivewin For Harbour v2.3

---------------------------------------------------------------  */

Static oScan, oWnd
Static  X := 0
Static  Y := 0
Static lChangeUnit := .F.

Function Main( cFile, nType, nRes, lHide, lInterface, nPaper )

   Local hDib := 0
   Local oImage, oBar, oBtn, oFont, oCbx, oCbxU, oCbxR, oGet, oCheck
   Local lSave := .F.
   Local cType
   Local aTypes       := { "1-Scale Gray","2-Real Color","3-Palette Color" }
   Local aResolutions := { "0","75","100","150","200","300" }
   Local aUnits       := { "0-Dpi","1-Cms","2-Picas","3-Points","4-Twips","6-Pixels"}
   Local cUnit := aUnits[1]
   Local nUnit := 0
   Local cFormat

   IF cFile = "/?" .OR. Empty(cFile) .OR. cFile = "?"
      ? "(c)2003 ScanFive For [x]Harbour by Rafa Carmoma(TheFull)"+CRLF+;
        "Parameters:" + CRLF +;
        "[File] [Type] [nResolution] [lHide] [lInterFace]" + CRLF+;
        "Example: ScanFive .\test.jpg 1 75 .T."
      quit
   ENDIF

   IF lInterFace = ".F." .OR. lInterFace = NIL
      lInterface := .F.
   ELSEIF lInterFace = ".T."
      lInterface := .T.
   ENDIF

   IF nRes = NIL
      nRes := "0"
   ENDIF

   IF lHide = ".T." .OR. lHide = NIL
      lHide := .T.
   ELSEIF lHide = ".F."
      lHide := .F.
   ENDIF

   // Default RGB
   IF nType == NIL
      nType :=  TWPT_GRAY
   ELSEIF Val( nType ) <= 3
      nType := Val( nType )
   ELSEIF Val( nType ) > 3
      MsgStop( "Not exist type." + CRLF+;
               "Real Color by Default", "Atention" )
      nType := TWPT_RGB
   ENDIF

   cType := aTypes[ nType  ]

   IF cFile = NIL
      cFile := ".\TestScan" + cFormat
   ENDIF


   oScan := TScan32():New( cFile )


IF lInterFace

   DEFINE FONT oFont NAME"Tahoma" SIZE 0,-10


   DEFINE WINDOW oWnd TITLE "Fichero: "+ oScan:cFile FROM 1,1 TO 500,650 PIXEL


   DEFINE BUTTONBAR oBar SIZE 50,32 3D OF oWnd

   DEFINE BUTTON oBtn PROMPT "Exit"  FONT oFont ;
          ACTION oWnd:End() OF oBar

   DEFINE BUTTON oBtn PROMPT "Grabar"  FONT oFont ;
          ACTION ( oScan:ClipBoardToFile( cFile ),;
                   SysRefresh() ) OF oBar

   DEFINE BUTTON oBtn PROMPT "Scan"  FONT oFont ;
          ACTION IF( ScanFive(  nType , nRes, nUnit, lHide ),;
                             ( oImage:LoadFromClipboard(), oImage:Refresh()) ,) OF oBar

   @5,175 CHECKBOX oCheck VAR lChangeUnit PROMPT "SetUnit" SIZE 70,20 OF oBar PIXEL

   @3,250 COMBOBOX oCbxR VAR nRes  SIZE 100,130 ;
           ITEMS aResolutions OF oBar PIXEL ;
           WHEN   nUnit = 0  UPDATE

   @3,350 COMBOBOX oCbx VAR cType  SIZE 120,130 ;
           ITEMS  aTypes OF oBar PIXEL ;
           ON CHANGE nType := Val( SubStr( cType,1,1 ) )

   @3,470 COMBOBOX oCbxU VAR cUnit  SIZE 100,130 ;
           ITEMS  aUnits OF oBar PIXEL ;
           ON CHANGE nUnit := Val( SubStr( cUnit,1,1 ) ) ;
           UPDATE

   @7,570  GET oGet VAR X PICTURE "9999.99" SIZE 60,20 OF oBar ;
           UPDATE PIXEL

   @7,630  GET oGet VAR Y PICTURE "9999.99" SIZE 60,20 OF oBar ;
           UPDATE PIXEL


   @0,0 BITMAP oImage SCROLL OF oWnd
   oWnd:oClient := oImage

   oWnd:Center()

   SET MESSAGE TO "(c)2003-Scan ClipBoard Beta 4 by Rafa Carmona" OF oWnd CENTER

   // Vaciamos el Clipboard a la salida de la Aplicacion.
   // Empty Clipboard to Exit aplicattion.
   ACTIVATE WINDOW oWnd VALID( oFont:End(), oScan:End(),;
                               OpenClipBoard( oWnd:hWnd ),;
                               EmptyClipboard(),;
                               CloseClipBoard(),.T. )

ELSE
   // Line Command 'a traves' of ClipBoard
   IF ScanFive( nType, nRes, 0 ,lHide )
      oScan:ClipBoardToFile( cFile )
      Return .T.    // Scan
   ELSE
      Return .F.    // Not Scan
   ENDIF

ENDIF

Return NIL


// Scanner al Clipboard
// nType -> Tipo de Salida
// nRes  -> Resolucion de salida
// nUnit -> Sistema de Medida

Static Func ScanFive( nType, nRes , nUnit, lHide )


      if oScan:State() < 4
         oScan:OpenDefault()
      endif

      if nUnit = 0 .AND. nRes != "0"
         oScan:SetRes( Val( nRes ) )
      endif

      IF nUnit > 0
         if lChangeUnit
            oScan:SetUnits( nUnit )   // Sistema de Medida .Esto puede causar problema
         endif
         // Expresado en Dpi. Habria que convertir pero no tengo ni idea de como.
         oScan:SetXRes( X )
         oScan:SetYRes( Y )
      ENDIF

      oScan:SetHide( lHide )              // Oculto DS
      oScan:PixelType( nType )

Return oScan:AcquireClipBoard()


